/****************************************************************************/
/*                                                                          */
/*         Intento de busqueda de caminos para una aventura grafica         */
/*                                                                          */
/* PROGRAMADO POR : MaaS (maas@ran.es)                                      */
/* TIEMPO : 10 horas (aprox)                                                */
/* FECHA : 31/3/98 - 19:53                                                  */
/*                                                                          */
/* El programa incluye un modo DEBUG con el que se vera el mapa de durezas  */
/* como fondo, el size del personaje y las coordenadas del cursor           */
/*                                                                          */
/****************************************************************************/

PROGRAM camino;
CONST
    num_caminos=3;      // Numero de caminos en la estancia
    velocidad=10;       // Velocidad del personaje (PNJ)
    dist_min=6;         // Distancia minima a partir de la cual se para
                        // el PNJ
GLOBAL

// Tabla de graficos para usar con xgraph

    tabla_quieto[]=8,-5,-4,3,4,5,6,7,-6;

// Caminos iniciales, finales y el actual

    cam_ini;cam_fin;cam_actual;

// Coordenadas x,y de final de trayectoria
    x_fin;y_fin;

// Cambio de direccion... 0 no ha cambiado, 1 cambia la direccion para los
// cruces
    cambio=0;

// Estructura que define los caminos...

    STRUCT caminos[num_caminos]
        color;                      // El color del mapa de durezas
        punto_x;                    // Punto x e y de referencia (solo para
        punto_y;                    // los cruces y caminos con perspectiva
        perspectiva;                // Codigo de perspectiva
        pers_x;                     // Coordenadas a partir de las cuales
        pers_y;                     // se activa la perspectiva
        min;                        // Tamao minimo de size en perspectiva
    END = 255,268,261,0,0,0,0,
          24,0,0,0,0,0,0,
          56,103,100,1,206,196,75,
          40,0,0,0,0,0,0;

    ident;

BEGIN
    set_mode(m640x480);
    load_fpg("camino.fpg");
    mouse.graph=8;
    put_screen(0,1);
    ident=pnj();

// Hasta aqui lo tipico

    LOOP

/* Cambio entre el modo DEBUG y el normal... no lo he quitado para que la
pea pueda ver como es el mapa de durezas y como afecta al programa. Ademas
arriba a la izquierda salen los valores de size para comprobar la perspectiva
y las coordenadas del raton */

        IF(key(_1))
            delete_text(all_text);
            clear_screen();
            put_screen(0,1);
        END
        IF(key(_2))
            delete_text(all_text);
            clear_screen();
            put_screen(0,2);
            write(0,10,10,3,"RATON");
            write(0,10,30,3,"SIZE");
            write_int(0,50,10,3,&mouse.x);
            write_int(0,80,10,3,&mouse.y);
            write_int(0,50,30,3,&ident.size);
        END
        FRAME;
    END
END

PROCESS pnj()
PRIVATE
        tot;            // Variables usadas en caminos con perspectiva
        dist_actual;
BEGIN
    xgraph=OFFSET tabla_quieto;     // Se activa el xgraph con los graficos
    x=550;y=280;angle=180000;       // Posicion y angulos iniciales
    x_fin=x;y_fin=y;

    LOOP

/* Si se pulsa el raton se hace la proyeccion de las coordenadas de este...
es decir, se busca cual es el camino maas cercano y la proyeccion del raton en
este. Imaginad que quereis ir por un caminito a una cascada, por ejemplo, pero
el no podeis hacer click SIEMPRE dentro del camino, generalmente se le da maas
o menos cerca de la cascada.... pos proyeccion() calcula cual es el camino que
querias haber dado */

        IF(mouse.left) proyeccion(mouse.x,mouse.y);END

/* Esto mira cual es el camino en el que se encuentra el PNJ mirando el mapa
de durezas */

        FROM cam_actual=0 TO num_caminos;
            IF(map_get_pixel(0,2,x,y)==caminos[cam_actual].color) BREAK;END
        END

/* Si las coordenadas actuales y finales son distintas HAY un sitio al que
moverse... con esto me ahorro el uso del tipico MOV=0, MOV=1 ... */

        IF(x!=x_fin||y!=y_fin)

/* Si el camino inical y final (calculados en proyeccion()) son el mismo, se
avanza directamente en linea recta (la proxima version incluira soporte para
caminos "serpenteantes" y no necesariamente rectos)*/

            IF(cam_ini==cam_fin)
                angle=fget_angle(x,y,x_fin,y_fin);
                advance(velocidad);
                IF(fget_dist(x,y,x_fin,y_fin)<dist_min)
                    x=x_fin;
                    y=y_fin;
                END

// Que no es el mismo?

            ELSE

/* Pues primero diriges al pnj al cruce (por defecto SIEMPRE se ponen los
cruces en caminos[0], y de caminos[1] en adelante los caminos) cambio=0 */

                IF(cambio==0)
                    angle=fget_angle(x,y,caminos[0].punto_x,caminos[0].punto_y);
                    advance(velocidad);
                    IF(fget_dist(x,y,caminos[0].punto_x,caminos[0].punto_y)<5)cambio=1;END

/* Cuando llegas al cruze, cambio=1, ya te puedes dirigir en linea recta al
punto final, x_fin, y_fin */

                ELSE
                    angle=fget_angle(x,y,x_fin,y_fin);
                    advance(velocidad);
                    IF(fget_dist(x,y,x_fin,y_fin)<dist_min)
                        x=x_fin;
                        y=y_fin;
                        cambio=0;
                    END
                END
            END
        END

// Por si resulta que te sales del camino, das marcha atras

        WHILE(map_get_pixel(0,2,x,y)==0)advance(-velocidad);END

/* Ahora lo chungo de explicar... la perspectiva... que el camino actual
tiene perspectiva? */

        IF(caminos[cam_actual].perspectiva!=0)

/* Primero se calcula el TOTAL de camino desde el punto de perspectiva al
punto de referencia... el de referencia es el punto maas alejado, donde el
size es minimo, el punto de perspectiva es el punto a partir del cual se
establece la perpectiva, a partir del que se reduce el size (dependiendo del
tipo de perspectiva) */

            tot=fget_dist(caminos[cam_actual].punto_x,
                          caminos[cam_actual].punto_y,
                          caminos[0].pers_x,
                          caminos[0].pers_y);

/* La distancia actual es la distancia del pnj al final del camino, al punto
de referencia... mientras maas cerca este del punto de referencia maas pequeo
sera su tamao (dependiendo del tipo de perspectiva) */

            dist_actual=fget_dist(caminos[cam_actual].punto_x,
                                  caminos[cam_actual].punto_y,
                                  x,y);

/* Aunque es imposible que la distancia total sea 0, algun error al poner los
datos en la struct puede desconcertar... mejor evitar dividir entre 0 */

            IF(tot==0)tot=1;END

/* Switch del tipo de perspectiva... en esta version SOLO he incluido una
perspectiva horizontal decreciente, codigo 1 (para el case 1), codigo 2 sera
horizontal creciente, 3 vertical decreciente y 4 vertical creciente... pero
quiero hacer mapas con caminos del tipo para poder ver mejor los errores */

            SWITCH(caminos[cam_actual].perspectiva)

                CASE 1 :

// Si traspasas la linea horizontal de perspectiva

                    IF(y<caminos[cam_actual].pers_y)

/* Explicar la formula no es tan facil como parece, pero es una simple regla
de tres... al minimo tamao de perpectiva del camino (caminos[cam_actual].min)
se le suma el tanto por ciento restante para formar el size...

    DISTANCIA TOTAL             -               100 - TAMAO MINIMO
    DISTANCIA ACTUAL            -                       X

    X = [DISTANCIA ACTUAL * (100 - TAMAO MINIMO)] / DISTANCIA TOTAL

Al sumar este dato al tamao minimo te resulta es size... Es decir, si el
tamao minimo es 75, la distancia actual debe ser 0, lo que da el resultado de
size = 75 + 0 / DISTANCIA TOTAL = 75... el minimo... si la distancia actual es
maxima sera igual a la distancia total con lo que al multiplicar y dividir por
el mismo numero quedaria solo el 100 - TAMAO MINIMO, es decir,
size = 75 + (100 - 75) = 100 */

                        size=(caminos[cam_actual].min+((dist_actual*(100-caminos[cam_actual].min))/tot));
                    ELSE size=100; END

// Como la formula es MUY dificil de testear para evitar errores pongo esto

                    IF(size>100) size=100;END
                END

                CASE 2 : END
                CASE 3 : END
                CASE 4 : END
            END
        END

        FRAME;
    END
END

// Lo de la proyeccion es largo pero muy facilito...

PROCESS proyeccion(pos_x,pos_y)
PRIVATE dir_arr_x;  // Todo esto son coordenadas x,y ...
        dir_arr_y;
        dir_aba_x;
        dir_aba_y;
        dir_izq_x;
        dir_izq_y;
        dir_der_x;
        dir_der_y;
BEGIN

// Lo primero es decir cual es el camino inicial ...

    FROM cam_ini=0 TO num_caminos;
        IF(map_get_pixel(0,2,father.x,father.y)==caminos[cam_ini].color) BREAK;END
    END

// ... y el final

    FROM cam_fin=0 TO num_caminos;
        IF(map_get_pixel(0,2,pos_x,pos_y)==caminos[cam_fin].color) BREAK;END
    END

/* Si el camino inicial resultante es uno de los definidos, no hace falta
buscar proyecciones ya que has clickeado EN un camino */

    IF(cam_fin!=4)
        x_fin=pos_x;
        y_fin=pos_y;
        RETURN();
    END

// Pero si no... hay que hacer las proyecciones

    dir_arr_x=pos_x;    // Igualo todas las coordenadas x,y a las del raton
    dir_arr_y=pos_y;    // que han entrado en la funcion como pos_x, pos_y
    dir_aba_x=pos_x;
    dir_aba_y=pos_y;
    dir_izq_x=pos_x;
    dir_izq_y=pos_y;
    dir_der_x=pos_x;
    dir_der_y=pos_y;

/* Estos cuatro while's... se trata de incrementar las cuatro coordenadas,
hacia arriba, abajo, izquierda y derecha hasta que se choquen con un camino,
las que salen de la pantalla sin chocar se les hace el BREAK */

    WHILE(map_get_pixel(0,2,dir_aba_x,dir_aba_y)==0)
        dir_aba_y++;
        IF(dir_aba_y>480)BREAK;END
    END

    WHILE(map_get_pixel(0,2,dir_arr_x,dir_arr_y)==0)
        dir_arr_y--;
        IF(dir_arr_y<0)BREAK;END
    END

    WHILE(map_get_pixel(0,2,dir_izq_x,dir_izq_y)==0)
        dir_izq_x--;
        IF(dir_izq_x<0)BREAK;END
    END

    WHILE(map_get_pixel(0,2,dir_der_x,dir_der_y)==0)
        dir_der_x++;
        IF(dir_der_x>640)BREAK;END
    END

/* Ahora toca saber CUAL de los cuatro caminos es el maas corto... y tomarlo
como el camino que tomara el pnj */

// Abajo

    IF(fget_dist(pos_x,pos_y,dir_aba_x,dir_aba_y)<fget_dist(pos_x,pos_y,dir_arr_x,dir_arr_y)&&
       fget_dist(pos_x,pos_y,dir_aba_x,dir_aba_y)<fget_dist(pos_x,pos_y,dir_izq_x,dir_izq_y)&&
       fget_dist(pos_x,pos_y,dir_aba_x,dir_aba_y)<fget_dist(pos_x,pos_y,dir_der_x,dir_der_y))

        x_fin=dir_aba_x;
        y_fin=dir_aba_y;
    END

// Arriba

    IF(fget_dist(pos_x,pos_y,dir_arr_x,dir_arr_y)<fget_dist(pos_x,pos_y,dir_aba_x,dir_aba_y)&&
       fget_dist(pos_x,pos_y,dir_arr_x,dir_arr_y)<fget_dist(pos_x,pos_y,dir_izq_x,dir_izq_y)&&
       fget_dist(pos_x,pos_y,dir_arr_x,dir_arr_y)<fget_dist(pos_x,pos_y,dir_der_x,dir_der_y))

        x_fin=dir_arr_x;
        y_fin=dir_arr_y;
    END

// Izquierda

    IF(fget_dist(pos_x,pos_y,dir_izq_x,dir_izq_y)<fget_dist(pos_x,pos_y,dir_aba_x,dir_aba_y)&&
       fget_dist(pos_x,pos_y,dir_izq_x,dir_izq_y)<fget_dist(pos_x,pos_y,dir_arr_x,dir_arr_y)&&
       fget_dist(pos_x,pos_y,dir_izq_x,dir_izq_y)<fget_dist(pos_x,pos_y,dir_der_x,dir_der_y))

        x_fin=dir_izq_x;
        y_fin=dir_izq_y;
    END

// Derecha

    IF(fget_dist(pos_x,pos_y,dir_der_x,dir_der_y)<fget_dist(pos_x,pos_y,dir_aba_x,dir_aba_y)&&
       fget_dist(pos_x,pos_y,dir_der_x,dir_der_y)<fget_dist(pos_x,pos_y,dir_izq_x,dir_izq_y)&&
       fget_dist(pos_x,pos_y,dir_der_x,dir_der_y)<fget_dist(pos_x,pos_y,dir_arr_x,dir_arr_y))

        x_fin=dir_der_x;
        y_fin=dir_der_y;
    END

/* Ahora toca repetir lo de hallar el camino final, puesto que es lo que
acabamos de hallar */

    FROM cam_fin=0 TO num_caminos;
        IF(map_get_pixel(0,2,x_fin,y_fin)==caminos[cam_fin].color) BREAK;END
    END
END
